# -*- coding:Utf-8 -*-
import es, re, psyco, random, gamethread, maplistlib, simplemenulib, dm_language
from dm_config import dmConfig
psyco.full()


importname = __import__(__name__)
regex = re.compile('//.*|(\r|\n|")+')
currentmap = es.ServerVar("eventscripts_currentmap")
maplist = maplistlib.MapList("cfg/dm_python/vote/maplist.txt", True)
mapfile = es.getString("eventscripts_gamedir") + "/cfg/dm_python/vote/maplist.txt"

class DmVotemap(object):
    """ Weapon Management """

    def __init__(self):
        self.maplist = []
        self.lastmap = []
        self.islaunched = False
        self.vote = simplemenulib.vote("_dm_python_deathmatch_vote")
        self.vote.addlist("_dm_python_list_menu")

    def i_level(self, level):
        es.forcevalue("eventscripts_nextmapoverride", level)
        es.createentity("game_end")
        es.fire(es.getuserid(), "game_end", "endgame")

    def i_end(self, answer, value, votes, total, players, percent, votename):
        if value:
            sound = str(dmConfig.startsound)
            gamethread.delayed(5, self.i_level, value)
            players = [userid for userid in es.getUseridList() if not es.isbot(userid)]
            for userid in players:
                if sound: es.playsound(userid, sound, 1)
                es.tell(userid, "#multi", dm_language.message(userid, "deathmatch vote win", {"nextmap" : value}))

    def newmap(self):
        self.read()
        self.islaunched = False
        self.lastmap.insert(0, str(currentmap))
        self.lastmap = self.lastmap[:int(dmConfig.lastmaps)]

    def check(self, score):
        if not self.islaunched:
            kills = int(dmConfig.kills)
            if kills:
                if int(score) >= kills: self.submit()

    def read(self):
        self.maplist = maplist.getlist()

    def submit(self):
        maplist = self.maplist[:]
        for mapname in self.lastmap:
            if mapname in maplist: maplist.remove(mapname)
        mapcount = len(maplist)
        mapmax = int(dmConfig.maxmap)
        if mapmax: maplist = random.sample(maplist, mapmax if mapmax <= mapcount else mapcount)

        players = [user for user in es.getUseridList() if not es.isbot(user)]
        if maplist and players:
            self.vote = simplemenulib.vote("_dm_python_deathmatch_vote")
            self.vote.loadlang("cfg/dm_python/language/deathmatch_vote.ini")
            self.vote.question("deathmatch vote title", showpage = len(maplist) > 8)
            for mapname in maplist: self.vote.addanswer("deathmatch vote answer", mapname, {"$mapname" : mapname})
            self.vote.blockendvote = self.i_end
            self.vote.submit(time = int(dmConfig.time), prio = True)

            sound = str(dmConfig.startsound)
            if sound:
                for userid in players: es.playsound(userid, sound, 1)
            self.islaunched = True

# create DmVotemap object
dmVotemap = DmVotemap()
